# TODO
# - see and adopt: http://gist.github.com/359890
%define		plugin	check_raid
%include	/usr/lib/rpm/macros.perl
Summary:	Nagios plugin to check current server's RAID status
Name:		nagios-plugin-%{plugin}
Version:	4.0.10
Release:	1
License:	GPL v2
Group:		Applications
Source0:	https://github.com/glensc/nagios-plugin-check_raid/archive/%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	44d42b711ea234f69c1103f731a4c461
Patch0:		maxcache.patch
Patch1:		bbu.patch
URL:		https://github.com/glensc/nagios-plugin-check_raid
BuildRequires:	perl-ExtUtils-MakeMaker-CPANfile
BuildRequires:	perl-Module-Pluggable >= 5.1
BuildRequires:	perl-Monitoring-Plugin >= 0.37
BuildRequires:	rpm-perlprov >= 4.1-13
BuildRequires:	rpmbuild(macros) >= 1.685
Requires:	grep
Requires:	nagios-common
Requires:	perl-base >= 1:5.8.0
Requires:	sed >= 4.0
Requires:	sudo >= 1:1.8.7-2
Suggests:	CmdTool2
Suggests:	arcconf
Suggests:	areca-cli
Suggests:	cciss_vol_status
Suggests:	hpacucli
Suggests:	lsscsi
Suggests:	megacli-sas
Suggests:	megarc-scsi
Suggests:	mpt-status
Suggests:	mvcli
Suggests:	smartmontools
Suggests:	tw_cli-9xxx
# cciss_vol_status 1.10 can process /dev/sdX instead of only /dev/sgX
Conflicts:	cciss_vol_status < 1.10
Conflicts:	nagios-nrpe < 2.15-5
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_sysconfdir	/etc/nagios/plugins
%define		nrpeddir	/etc/nagios/nrpe.d
%define		plugindir	%{_prefix}/lib/nagios/plugins

%description
This plugin chekcs Check all RAID volumes (hardware and software) that
can be identified.

Supports:
- AIX software RAID via lsvg
- Adaptec AAC RAID via aaccli or afacli or arcconf
- Areca SATA RAID Support
- HP Smart Array (MSA1500) via serial line
- HP Smart Array Controllers and MSA Controllers via hpacucli (see
  hapacucli readme)
- HP/Compaq Smart Array via cciss_vol_status (hpsa supported too)
- LSI Logic MegaRAID SAS series via MegaCli
- LSI MegaRaid via lsraid
- Linux 3ware SATA RAID via tw_cli
- Linux DPT/I2O hardware RAID controllers via /proc/scsi/dpt_i2o
- Linux GDTH hardware RAID controllers via /proc/scsi/gdth
- Linux LSI MegaRaid hardware RAID via /proc/megaraid
- Linux LSI MegaRaid hardware RAID via CmdTool2
- Linux LSI MegaRaid hardware RAID via megarc
- Linux MPT hardware RAID via mpt-status
- Linux Device Mapper
- Linux MegaIDE hardware RAID controllers via /proc/megaide
- Linux software RAID (md) via /proc/mdstat
- SAS2IRCU support
- Serveraid IPS via ipssend
- Solaris software RAID via metastat

%prep
%setup -qc
mv nagios-plugin-check_raid-*/* .
%patch0 -p1
%patch1 -p1

# set version
%{__sed} -i -e '
    s#my $VERSION = q.*;#my $VERSION = q/%{version}-%{release}/;#
' bin/%{plugin}.pl

%build
# version check exits with "3", here's explanation:
# https://github.com/monitoring-plugins/monitoring-plugins/pull/1363
ver=$(./%{plugin}.sh -V || :)
test "$(echo "$ver" | awk '{print $NF}')" = %{version}-%{release}

LC_ALL=en_US.utf8 \
%{__perl} Makefile.PL \
	INSTALLVENDORSCRIPT=%{plugindir} \
	INSTALLDIRS=vendor
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sysconfdir},%{nrpeddir},%{plugindir},/etc/sudoers.d}
%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

cp -p %{plugin}.cfg $RPM_BUILD_ROOT%{_sysconfdir}
touch $RPM_BUILD_ROOT%{nrpeddir}/%{plugin}.cfg
touch $RPM_BUILD_ROOT/etc/sudoers.d/check_raid

# remove .pl extension
mv $RPM_BUILD_ROOT%{plugindir}/%{plugin}{.pl,}

# cleanup
%{__rm} $RPM_BUILD_ROOT%{perl_archlib}/perllocal.pod
%{__rm} $RPM_BUILD_ROOT%{perl_vendorarch}/auto/App/Monitoring/Plugin/CheckRaid/.packlist

%clean
rm -rf $RPM_BUILD_ROOT

%post
# setup sudo rules:
# - on first install
# - if separate config file is used
grep -q '^#includedir /etc/sudoers\.d' /etc/sudoers && confd=1

if [ "$1" = 1 ] || [ "$1" = "configure" ] || [ "$confd" = 1 ]; then
	%{plugindir}/%{plugin} -S || :
fi

%postun
if [ "$1" = "0" ] || [ "$1" = "remove" ]; then
	# remove all sudo rules related to us
	%{__sed} -i -e '/CHECK_RAID/d' /etc/sudoers
fi

%triggerpostun -- %{name} < 3.1.1-0.2, sudo < 1:1.8.7-2
if grep -q '^#includedir /etc/sudoers\.d' /etc/sudoers; then
	%{plugindir}/%{plugin} -S || :
fi
# remove CHECK_RAID rules from /etc/sudoers if separate config is in place
if [ -e /etc/sudoers.d/check_raid ]; then
	%{__sed} -i -e '/CHECK_RAID/d' /etc/sudoers
fi

%triggerin -- nagios-nrpe
%nagios_nrpe -a %{plugin} -f %{_sysconfdir}/%{plugin}.cfg

%triggerun -- nagios-nrpe
%nagios_nrpe -d %{plugin} -f %{_sysconfdir}/%{plugin}.cfg

%files
%defattr(644,root,root,755)
%attr(640,root,nagios) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/%{plugin}.cfg
%attr(755,root,root) %{plugindir}/%{plugin}
%ghost %{nrpeddir}/%{plugin}.cfg
%ghost /etc/sudoers.d/check_raid
%dir %{perl_vendorlib}/App/Monitoring
%dir %{perl_vendorlib}/App/Monitoring/Plugin
%{perl_vendorlib}/App/Monitoring/Plugin/CheckRaid.pm
%{perl_vendorlib}/App/Monitoring/Plugin/CheckRaid
%changelog
* Thu May 16 2019 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/nagios-plugin-check_raid.git;a=log;h=master

* Thu May 16 2019 Elan Ruusamäe <glen@pld-linux.org> 35562ff
- up to 4.0.10

* Tue Jan 29 2019 Elan Ruusamäe <glen@pld-linux.org> 3b66fd1
- up to 4.0.9

* Tue Dec 11 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> cc8cea2
- rel 4; just enable bbu monitoring by default and be done with it

* Tue Dec 11 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 46ad8dd
- rel 3; use separate config, so nagios_nrpe rpm macros can deal with it

* Tue Dec 11 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 5fe3688
- rel 2; plugin doesn't monitor bbu by default, so provide separate template command and template for that

* Fri Sep 01 2017 Elan Ruusamäe <glen@pld-linux.org> da0d8b5
- up to 4.0.8

* Tue Jun 20 2017 Elan Ruusamäe <glen@pld-linux.org> fd57e8f
- deb: specify runtime dependencies

* Fri Jun 16 2017 Elan Ruusamäe <glen@pld-linux.org> 3792654
- added script to create .deb package

* Fri Jun 16 2017 Elan Ruusamäe <glen@pld-linux.org> 46a85d7
- make scriptlets debian compatible (via alien)

* Thu Apr 20 2017 Elan Ruusamäe <glen@delfi.ee> 3b4698d
- up to 4.0.6

* Wed Feb 01 2017 Arkadiusz Miśkiewicz <arekm@maven.pl> f189a9e
- here my arcconf reports 'maxCache 3.0 information' so compare in case insensitive way

* Wed Feb 01 2017 Arkadiusz Miśkiewicz <arekm@maven.pl> 5dfc7ee
- up to 4.0.5

* Sat Nov 19 2016 Elan Ruusamäe <glen@delfi.ee> 5e3e65c
- up to 4.0.3 - 2016-11-20

* Mon Mar 14 2016 Elan Ruusamäe <glen@delfi.ee> a9655cb
- set utf8 locale

* Mon Mar 14 2016 Elan Ruusamäe <glen@delfi.ee> 5de6f20
- up to 4.0.2; adds Device-Mapper checker

* Wed Mar 02 2016 Elan Ruusamäe <glen@delfi.ee> bd50b17
- own sudoes config file (as ghost)

* Mon Feb 29 2016 Elan Ruusamäe <glen@delfi.ee> 6134e2e
- md5 fix

* Mon Feb 29 2016 Elan Ruusamäe <glen@delfi.ee> 77a58f2
- up to 4.0.1

* Thu Feb 25 2016 Elan Ruusamäe <glen@delfi.ee> f95c338
- version from cpanfile

* Thu Feb 25 2016 Elan Ruusamäe <glen@delfi.ee> 5c7c000
- BR update

